Index: /trunk/src/ListDir.m
===================================================================
--- /trunk/src/ListDir.m	(revision 30)
+++ /trunk/src/ListDir.m	(revision 30)
@@ -0,0 +1,118 @@
+%'ListDir': scan the structure of the directory tree (for dataview.m)
+%------------------------------------------------------------------------
+% function [ListDevices,ListRecords,ListXml,List]=ListDir(CurrentPath,ListExperiments,ListDevices_in,ListRecords_in)
+%
+% 
+% OUTPUT:
+% ListDevices: list of Devices 
+% ListRecords: list of records
+% ListXml: list of xml file names
+% List: structure representing the tree structure
+%
+%INPUT
+% CurrentPath: full name (including path) to the input campaign (or subcampaign), we assume that
+%          data are organised as (sub)campaign/Experiment/Device/(Record/)/file .xml
+% ListExperiments: list of experiments to scan (cell of names)
+% ListDevices_in: list of devices to scan (cell of names)
+% ListRecords_in: list of records to scan (cell of names)
+
+function [ListDevices,ListRecords,ListXml,List]=ListDir(CurrentPath,ListExperiments,ListDevices_in,ListRecords_in)
+
+ListRecords={};
+ListDevices={};
+ListXml={};
+irecord_tot=0;
+idevice_tot=0;
+ixml_tot=0;
+for iexp=1:length(ListExperiments) 
+    List.Experiment{iexp}.name=ListExperiments{iexp};
+    hdir=dir(fullfile(CurrentPath,ListExperiments{iexp}));
+    idevice=0;
+    for isub=1:length(hdir)% scan the sub-directories  of the current experiment       
+        if hdir(isub).isdir
+            name=hdir(isub).name;%name of the current device
+            if ~isequal(name(1),'.')% subdirectory of the current experiment
+                [testnew,testselect]=test_select(name,ListDevices,ListDevices_in);
+                if testselect
+                    idevice=idevice+1;
+                    List.Experiment{iexp}.Device{idevice}.name=name;             
+                    if testnew
+                         idevice_tot=idevice_tot+1;
+                         ListDevices{idevice_tot}=name;
+                    end
+                    CurrentDevice=fullfile(CurrentPath,ListExperiments{iexp},name);
+                    hsubxml=dir(fullfile(CurrentDevice,'*.xml'));%look at xml files in the subdirectory of the current device
+                    if isempty(hsubxml) % the subdirectory of the current device contains directories 'Record'' 
+                        hsubdir=dir(fullfile(CurrentPath,ListExperiments{iexp},name));%list what is inside the directory 'Device'   
+                        irecord=0;
+                        for isubsub=1:length(hsubdir)% subdirectories of the current device
+                            if hsubdir(isubsub).isdir                       
+                                RecordName=hsubdir(isubsub).name;  
+                                if ~isequal(RecordName(1),'.')
+                                    [testnew,testselect]=test_select(RecordName,ListRecords,ListRecords_in);
+                                    if testselect
+                                        if testnew
+                                            irecord_tot=irecord_tot+1;
+                                            ListRecords{irecord_tot}=RecordName;
+                                        end
+                                        irecord=irecord+1;
+                                        List.Experiment{iexp}.Device{idevice}.Record{irecord}.name=RecordName;
+                                        hsubsubxml=dir(fullfile(CurrentDevice,RecordName,'*.xml'));%
+                                        for ixml=1:length(hsubsubxml)
+                                            XmlName=hsubsubxml(ixml).name;
+                                            List.Experiment{iexp}.Device{idevice}.Record{irecord}.xmlfile{ixml}=XmlName;
+                                            testnew=test_select(XmlName,ListXml,{});
+                                            if testnew
+                                                ixml_tot=ixml_tot+1;
+                                                ListXml{ixml_tot}=XmlName;
+                                            end
+                                        end 
+                                    end              
+                                end
+                            end
+                        end
+                    else
+                        for ixml=1:length(hsubxml)
+                            XmlName=hsubxml(ixml).name;
+                            List.Experiment{iexp}.Device{idevice}.xmlfile{ixml}=XmlName;
+                            testnew=test_select(XmlName,ListXml,{});
+                            if testnew
+                                ixml_tot=ixml_tot+1;
+                                ListXml{ixml_tot}=XmlName;
+                            end
+                        end
+                    end
+                end
+            end
+        end
+    end
+end
+
+
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+% ListDevices: list of devices already scanned
+% ListDevices_in: list of input devices to scan
+function [testnew,testselect]=test_select(name,ListDevices,ListDevices_in)
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+if ~isempty(ListDevices_in)
+    testnew=0;
+    testselect=0;
+    for ilist=1:length(ListDevices_in)
+        if isequal(name,ListDevices_in{ilist})
+            testnew=1;
+            testselect=1; 
+            break
+        end
+    end
+else
+    testnew=1; 
+    testselect=1;
+end
+if testnew
+    for ilist=1:length(ListDevices)
+         if isequal(name,ListDevices{ilist})
+              testnew=0;
+              break
+         end
+    end
+end
Index: /trunk/src/imadoc2struct.m
===================================================================
--- /trunk/src/imadoc2struct.m	(revision 20)
+++ /trunk/src/imadoc2struct.m	(revision 30)
@@ -21,16 +21,16 @@
 s.TimeUnit=[]; %default
 s.GeometryCalib=[];
-nom_type_ima=[];%default
-ext_ima=[];%default
+% nom_type_ima=[];%default
+% ext_ima=[];%default
 % abs_time=[];%initiation
 % GeometryCalib.CoordUnit='cm';%default
-mode=[]; %default
-NbSlice=1;%default
-npx=[];%default
-npy=[];%default
+% mode=[]; %default
+% NbSlice=1;%default
+% npx=[];%default
+% npy=[];%default
 % GeometryCalib.Pxcmx=1;
 % GeometryCalib.Pxcmy=1;
 % GeometryCalib=[];
-NbDtj=1;
+% NbDtj=1;
 tsai=[];%default
 % if ~exist('testime','var')
@@ -64,8 +64,8 @@
     end
     s.Heading.ImageName=get(t,children(t,uid_FirstImage),'value');
-    FirstImage=s.Heading.ImageName;
-    if ~isempty(FirstImage)
-        [Pathsub,RootFile,field_count,str2,str_a,str_b,ext,nom_type_ima]=name2display(FirstImage);
-    end
+%     FirstImage=s.Heading.ImageName;
+%     if ~isempty(FirstImage)
+%         [Pathsub,RootFile,field_count,str2,str_a,str_b,ext,nom_type_ima]=name2display(FirstImage);
+%     end
 end
 
@@ -78,13 +78,13 @@
         xindex=findstr(ImageSize,'x');
         if length(xindex)>=2
-            npx=str2num(ImageSize(1:xindex(1)-1));
-            npy=str2num(ImageSize(xindex(1)+1:xindex(2)-1));
-        end
-    end
-    uid_NbSlice=find(t,'/ImaDoc/Camera/NbSlice');
-    if ~isempty(uid_NbSlice)
-        NbSlice=str2num(get(t,children(t,uid_NbSlice),'value'));
-        if isempty(NbSlice),NbSlice=1;end; %default
-    end
+%             npx=str2num(ImageSize(1:xindex(1)-1));
+%             npy=str2num(ImageSize(xindex(1)+1:xindex(2)-1));
+        end
+    end
+%     uid_NbSlice=find(t,'/ImaDoc/Camera/NbSlice');
+%     if ~isempty(uid_NbSlice)
+%         NbSlice=str2num(get(t,children(t,uid_NbSlice),'value'));
+% %         if isempty(NbSlice),NbSlice=1;end; %default
+%     end
     uid_TimeUnit=find(t,'/ImaDoc/Camera/TimeUnit');
     if ~isempty(uid_TimeUnit)
@@ -94,6 +94,6 @@
     if ~isempty(uid_BurstTiming)
         for k=1:length(uid_BurstTiming)
-            Dtj=[];%default
-            NbDtj=1;%default
+%             Dtj=[];%default
+%             NbDtj=1;%default
             subt=branch(t,uid_BurstTiming(k));%subtree under BurstTiming
              % reading Dtk
@@ -121,5 +121,5 @@
             % reading Dtk
             Dtk=get_value(subt,'/BurstTiming/Dtk',[]);
-            NbDtk=get_value(subt,'/BurstTiming/NbDtk',1)
+            NbDtk=get_value(subt,'/BurstTiming/NbDtk',1);
             if isempty(Dtk)
                 s.Time=[s.Time;Time_val];
@@ -141,5 +141,5 @@
 if ~isempty(uid_GeometryCalib)
     if length(uid_GeometryCalib)>1
-        error=['More than one GeometryCalib in ' filecivxml];
+        errormsg=['More than one GeometryCalib in ' filecivxml];
         return
     end
@@ -149,5 +149,5 @@
         uid_pixcmx=find(subt,'/GeometryCalib/Pxcmx');
         uid_pixcmy=find(subt,'/GeometryCalib/Pxcmy');
-        if ~isempty(uid_pixcmx) & ~isempty(uid_pixcmy)%NON UTILISE 
+        if ~isempty(uid_pixcmx) && ~isempty(uid_pixcmy)%NON UTILISE 
            pixcmx=str2num(get(subt,children(subt,uid_pixcmx),'value'));
             if isempty(pixcmx),pixcmx=1;end; %default
@@ -180,5 +180,5 @@
         uid_Tx_Ty_Tz=find(subt,'/GeometryCalib/Tx_Ty_Tz');
         uid_R=find(subt,'/GeometryCalib/R');
-        if ~isempty(uid_focal) & ~isempty(uid_dpx_dpy) & ~isempty(uid_Cx_Cy)
+        if ~isempty(uid_focal) && ~isempty(uid_dpx_dpy) && ~isempty(uid_Cx_Cy)
             tsai.f=str2num(get(subt,children(subt,uid_focal),'value'));
             dpx_dpy=str2num(get(subt,children(subt,uid_dpx_dpy),'value'));
Index: /trunk/src/nomtype2pair.m
===================================================================
--- /trunk/src/nomtype2pair.m	(revision 20)
+++ /trunk/src/nomtype2pair.m	(revision 30)
@@ -30,8 +30,8 @@
 % Dtj: ~=0 if i index pairs are used
 
-function [nom_type_pair]=nomtype2pair(nom_type,Dti,Dtj);
+function [nom_type_pair]=nomtype2pair(nom_type,Dti,Dtj)
 
 %determine nom_type_nc:
-nom_type_nc=[];%default
+nom_type_pair=[];%default
 switch nom_type
     case {'_i_j'}
Index: /trunk/src/read_geometry_calib.m
===================================================================
--- /trunk/src/read_geometry_calib.m	(revision 30)
+++ /trunk/src/read_geometry_calib.m	(revision 30)
@@ -0,0 +1,51 @@
+%'read_geometry_calib': read data on the GUI geometry_calib
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+function data=read_geometry_calib(Coord_cell)
+data_XIma=[];
+data_YIma=[];
+data_XObject=[];
+data_YObject=[];
+data_ZObject=[];
+%Coord=get(handles.ListCoord,'String');
+% XImage=get(handles.XImage,'String');
+% YImage=get(handles.YImage,'String');
+% XObject=get(handles.XObject,'String');
+% YObject=get(handles.YObject,'String');
+% ZObject=get(handles.ZObject,'String');
+% if ischar(Xcolumn)
+%     Xcolumn={Xcolumn};
+% end
+nb_defining_points=length(Coord_cell);
+iline=0;
+for i=1:nb_defining_points
+    coord_str=Coord_cell{i};%character string of line number i
+    k=findstr('|',coord_str);%find separators '|'
+    if length(k)>=4 % test for separators '|'
+        data1=str2num(coord_str(1:k(1)-5));
+        data2=str2num(coord_str(k(1)+5:k(2)-5));
+        data3=str2num(coord_str(k(2)+5:k(3)-5));
+        data4=str2num(coord_str(k(3)+5:k(4)-5));
+        data5=str2num(coord_str(k(4)+5:end));
+        if ~isempty(data1)|~isempty(data2)|~isempty(data3)|~isempty(data4)|~isempty(data5)
+            iline=iline+1;
+            if ~isempty(data1)
+                data.Coord(iline,1)=data1;
+            end    
+            if ~isempty(data2)
+                data.Coord(iline,2)=data2;
+            end
+            if ~isempty(data3)
+                data.Coord(iline,3)=data3;
+            end
+            if ~isempty(data4)
+                data.Coord(iline,4)=data4;
+            end
+            if isempty(data5)
+                data.Coord(iline,5)=0;
+            else
+                data.Coord(iline,5)=data5;
+            end
+        end
+    end
+end
+data.Style='points';
Index: /trunk/src/series.m
===================================================================
--- /trunk/src/series.m	(revision 20)
+++ /trunk/src/series.m	(revision 30)
@@ -55,5 +55,5 @@
 %--------------------------------------------------------------------------
 function series_OpeningFcn(hObject, eventdata, handles,param)
-
+global nb_builtin
 % Choose default command line output for series
 handles.output = hObject;
@@ -129,13 +129,15 @@
     set(handles.filter2,'Value',param.filter2);
 end
-%set(hObject,'UserData', SeriesData)
 set(hObject,'WindowButtonUpFcn',{@mouse_up_gui,handles}) 
 NomType_Callback(hObject, eventdata, handles)
-%mode_Callback(hObject, eventdata, handles)
 
 %loads the information stored in prefdir to initiate the browser and the list of functions
-menu_str=get(handles.ACTION,'String');%list of functions included in 'series.m'
-menu_str(end)=[];%remove from the list the last option 'more...'
-path_series=which('series');%path of the function 'series'
+menu_str={'check_files';'aver_stat';'time_series';'merge_proj';'clean_civ_cmx'};
+nb_builtin=numel(menu_str); %number of functions
+ 
+%remove from the list the last option 'more...'
+[path_series,name,ext]=fileparts(which('series'));
+path_series=fullfile(path_series,'/series');%path of the function 'series'
+
 for ilist=1:length(menu_str)
     fct_path{ilist,1}=path_series;%paths of the fuctions buil-in in 'series.m'
@@ -151,8 +153,9 @@
              menu_str=[menu_str; {file}];
          end
-         menu_str=[menu_str;{'more...'}];
-         set(handles.ACTION,'String',menu_str)
-    end
-end
+    end
+end
+
+menu_str=[menu_str;{'more...'}];
+set(handles.ACTION,'String',menu_str)
 set(handles.ACTION,'UserData',fct_path)% store the list of path in UserData of ACTION
 
@@ -286,7 +289,5 @@
 function MenuBrowse_insert_Callback(hObject, eventdata, handles)
 
-%hseries=get(handles.browse_root,'parent');
-RootPathCell=get(handles.RootPath,'String');
-% SubDirCell=get(handles.SubDir,'String');  
+RootPathCell=get(handles.RootPath,'String'); 
 RootFileCell=get(handles.RootFile,'String');
 oldfile=''; %default
@@ -392,8 +393,14 @@
 % refresh the GUI data after introduction of a new file series
 function update_file(hObject, eventdata, handles,fileinput,addtest)
-hseries=get(handles.RootPath,'parent');  
+%hseries=get(handles.RootPath,'parent');  
+if ~exist(fileinput,'file')
+    msgbox_uvmat('ERROR',['input file ' fileinput  ' does not exist'])
+    return
+end
+hseries=handles.figure1;
 % refresh input root name, indices, file extension and nomenclature
 [RootPath,RootFile,field_count,str2,str_a,str_b,FileExt,NomType,SubDir]=name2display(fileinput);
 %check for movie image files
+if ~isempty(FileExt)
 if ~isempty(imformats(FileExt(2:end)))
     imainfo=imfinfo(fileinput);     
@@ -402,4 +409,5 @@
         [RootPath,RootFile]=fileparts(fileinput);
     end
+end
 end
 NcType='none';%default
@@ -486,22 +494,12 @@
 drawnow
 
-% hseries=get(handles.RootFile,'parent');
-% SeriesData=get(hseries,'UserData');%read information set by the browser
-% ext_ima_read=[];
-% field_count=1;%default
-% pxcmx=1;
-% pxcmy=1;
 TimeUnit=''; %default
-% CoordUnit='';%default
 time=[];%default
 GeometryCalib=[];%default
 nb_field=[];%default
 nb_field2=[];%default
-% Heading=[];
-% [PD,Device]=fileparts(RootPathCell{1});
 SeriesData.PathCampaign=get(handles.PathCampaign,'String');
 
 % read timing and total frame number from the current file (movie files) !! may be overrid by xml file
-%icell=length(RootPathCell);
 FileBase=fullfile(RootPath,RootFile);
 
@@ -884,5 +882,6 @@
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 function mode_Callback(hObject, eventdata, handles)
-hseries=get(handles.mode,'parent');
+%hseries=get(handles.mode,'parent');
+hseries=handles.figure1;
 SeriesData=get(hseries,'UserData');
 mode_list=get(handles.mode,'String');
@@ -985,6 +984,6 @@
 %----------------------------------------------------------------
 function find_netcpair_civ(hObject, eventdata, handles,Val)
-hseries=get(handles.list_pair_civ,'parent');
-SeriesData=get(hseries,'UserData'); 
+%hseries=get(handles.list_pair_civ,'parent');
+SeriesData=get(handles.figure1,'UserData'); 
 % NomTypeCell=get(handles.NomType,'String');
 NomTypeCell=SeriesData.NomType;
@@ -1167,5 +1166,5 @@
 SeriesData.displ_num(iview,:)=(displ_num(:,val))';
 SeriesData.ref_time=ref_time;
-set(hseries,'UserData',SeriesData)
+set(handles.figure1,'UserData',SeriesData)
 list_pair_civ_Callback(hObject, eventdata, handles)
 
@@ -1179,6 +1178,6 @@
 Val=get(handles.RootPath,'Value');
 IndexCell=get(handles.NomType,'String');
-hseries=get(handles.list_pair_civ,'parent');
-SeriesData=get(hseries,'UserData');
+%hseries=get(handles.list_pair_civ,'parent');
+SeriesData=get(handles.figure1,'UserData');
 NomType=SeriesData.NomType{Val};
 list_pair=get(handles.list_pair_civ,'String');%get the menu of image pairs
@@ -1241,5 +1240,5 @@
 set(handles.NomType,'String',IndexCell)
 SeriesData.displ_num(Val,:)=displ_num;
-set(hseries,'UserData',SeriesData)
+set(handles.figure1,'UserData',SeriesData)
 % set(handles.NomType,'Value',Val)
 
@@ -1290,6 +1289,6 @@
 %read root name and field type
 set(handles.RUN,'BusyAction','queue');
-hseries=get(handles.RUN,'parent');
-set(0,'CurrentFigure',hseries)
+%hseries=get(handles.RUN,'parent');
+set(0,'CurrentFigure',handles.figure1)
 if isequal(get(handles.GetObject,'Value'),1) 
     Series.GetObject=1;
@@ -1298,5 +1297,5 @@
     Series.GetObject=0;
 end
-SeriesData=get(hseries,'UserData');
+SeriesData=get(handles.figure1,'UserData');
 if isfield(SeriesData,'sethandles')
     if iscell(SeriesData.sethandles)
@@ -1481,11 +1480,19 @@
     end
 end
+% fct_path
+eval(['h_fun=@' action ';'])
+if ~isequal(fct_path,path_series)
+        rmpath(fct_path)% add the prescribed path if not the current one    
+end
+
 Series.Action=action;%name of the processing programme
 set(handles.RUN,'BackgroundColor',[0.831 0.816 0.784])
 drawnow
 if length(RootPath)>1
-    feval(action,num_i1_cell,num_i2_cell,num_j1_cell,num_j2_cell,Series);
-else
-    feval(action,num_i1,num_i2,num_j1,num_j2,Series);
+%    feval(action,num_i1_cell,num_i2_cell,num_j1_cell,num_j2_cell,Series);
+    h_fun(num_i1_cell,num_i2_cell,num_j1_cell,num_j2_cell,Series);
+else
+    h_fun(num_i1,num_i2,num_j1,num_j2,Series);
+%     feval(action,num_i1,num_i2,num_j1,num_j2,Series);
 end
 set(handles.RUN,'BackgroundColor',[1 0 0])
@@ -1518,5 +1525,5 @@
 %----------------------------------------------
 function last_i_Callback(hObject, eventdata, handles)
-    hseries=get(handles.last_i,'parent');
+%     hseries=get(handles.last_i,'parent');
 first_i=str2num(get(handles.first_i,'String'));
 last_i=str2num(get(handles.last_i,'String'));
@@ -1524,5 +1531,5 @@
 set(handles.ref_i,'String', num2str(ref_i))
 ref_i_Callback(hObject, eventdata, handles)
-SeriesData=get(hseries,'UserData');
+SeriesData=get(handles.figure1,'UserData');
 if ~isfield(SeriesData,'Time')
     SeriesData.Time{1}=[];
@@ -1536,5 +1543,5 @@
 %-------------------------------------------------------
 function last_j_Callback(hObject, eventdata, handles)
-    hseries=get(handles.last_i,'parent');
+   % hseries=get(handles.last_i,'parent');
 first_j=str2num(get(handles.first_j,'String'));
 last_j=str2num(get(handles.last_j,'String'));
@@ -1543,5 +1550,5 @@
 
 ref_j_Callback(hObject, eventdata, handles)
-SeriesData=get(hseries,'UserData');
+SeriesData=get(handles.figure1,'UserData');
 if ~isfield(SeriesData,'Time')
     SeriesData.Time{1}=[];
@@ -1557,6 +1564,6 @@
 mode_value=get(handles.mode,'Value');
 mode=mode_list{mode_value};
-hseries=get(handles.ref_i,'parent');
-SeriesData=get(hseries,'UserData');
+%hseries=get(handles.ref_i,'parent');
+SeriesData=get(handles.figure1,'UserData');
 %NomTypeCell=get(handles.NomType,'String');
 NomTypeCell=SeriesData.NomType;
@@ -1578,16 +1585,13 @@
 mode_value=get(handles.mode,'Value');
 mode=mode_list{mode_value};
-hseries=get(handles.ref_i,'parent');
-SeriesData=get(hseries,'UserData');
-%NomTypeCell=get(handles.NomType,'String');
+%hseries=get(handles.ref_i,'parent');
+SeriesData=get(handles.figure1,'UserData');
 NomTypeCell=SeriesData.NomType;
 if ~isempty(NomTypeCell)
-Val=get(handles.NomType,'Value');
-NomType=NomTypeCell{Val};
-% NomType=get(handles.NomType,'String');
+    Val=get(handles.NomType,'Value');
+    NomType=NomTypeCell{Val};
     if isequal(NomType,'_i_j1-j2')|| isequal(NomType,'_i1-i2_j')|| isequal(NomType,'_i1-i2')
         if isequal(mode,'series(Dj)') 
             find_netcpair_civ(hObject, eventdata, handles,Val);% update the menu of pairs depending on the available netcdf files
-%             break
         end
     end
@@ -1597,4 +1601,5 @@
 % --- Executes on selection change in ACTION.
 function ACTION_Callback(hObject, eventdata, handles)
+global nb_builtin
 list_ACTION=get(handles.ACTION,'String');% list menu fields
 index_ACTION=get(handles.ACTION,'Value');% selected string index
@@ -1602,38 +1607,25 @@
 path_series=which('series');%path to series.m
 list_path=get(handles.ACTION,'UserData');%list of recorded paths to functions of the list ACTION
-nb_builtin=0;
-for ilist=1:length(list_path)
-    if isequal(list_path{ilist},path_series)
-        nb_builtin=nb_builtin+1;
-    else
-        break
-    end
-end
-if nb_builtin==0% the path of series has been changed, reinitialize
-    series_OpeningFcn(hObject, eventdata, handles)
-    return
-end
-
-% add a new function to the menu
+
+% add a new function to the menu if the selected item is 'more...'
 if isequal(ACTION,'more...')
     pathfct=fileparts(path_series);
-    browse_name=fullfile(path_series,'SERIES_FCT');%go to UVMAT/SERIES_FCT by default
-    if length(list_path)>nb_builtin
-        browse_name=list_path{end};% initialize browser with  the path of the last introduced function
-     end 
+%     browse_name=fullfile(path_series,'series');%go to UVMAT/series by default
+%     if length(list_path)>nb_builtin
+%         browse_name=list_path{end};% initialize browser with  the path of the last introduced function
+%      end 
     [FileName, PathName, filterindex] = uigetfile( ...
        {'*.m', ' (*.m)';
         '*.m',  '.m files '; ...
         '*.*', 'All Files (*.*)'}, ...
-        'Pick a file',browse_name);
+        'Pick a file',list_path{end});
     if length(FileName)<2
         return
-    end
-    ext_fct=FileName(end-1:end);
+    end 
+    [pp,ACTION,ext_fct]=fileparts(FileName);%(end-1:end);
     if ~isequal(ext_fct,'.m')
         msgbox_uvmat('ERROR','a Matlab function .m must be introduced');
         return
     end
-    ACTION=FileName(1:end-2);% ACTION choice updated by the selected item
     
    % insert the choice in the action menu
@@ -1641,5 +1633,5 @@
    index_ACTION=get(handles.ACTION,'Value');% currently selected index in the list
    list_path{index_ACTION}=PathName;
-   if length(menu_str)>nb_builtin+5;
+   if length(menu_str)>nb_builtin+5; %nb_builtin=nbre of functions always remaining in the initial menu
        nbremove=length(menu_str)-nb_builtin-5;
        menu_str(nb_builtin+1:end-5)=[];
@@ -1675,12 +1667,12 @@
 %check the current path to the selected function
 PathName=list_path{index_ACTION};%current recorded path
-if ~isequal(path_series,PathName)
-    CurrentPath=fileparts(which(ACTION));
-    if ~isequal(CurrentPath,PathName)&&~isequal(CurrentPath,fullfile(PathName,'private'))
-        addpath(PathName) 
-        errormsg=check_functions;
-        msgbox_uvmat('CONFIRMATION',[['path ' PathName ' added to the current Matlab pathes'];errormsg])
-    end
-end
+% if ~isequal(path_series,PathName)
+%     CurrentPath=fileparts(which(ACTION));
+%     if ~isequal(CurrentPath,PathName)
+%         addpath(PathName) 
+%         errormsg=check_functions;
+%         msgbox_uvmat('CONFIRMATION',[['path ' PathName ' added to the current Matlab pathes'];errormsg])
+%     end
+% end
 set(handles.path,'String',PathName); %show the path to the senlected function
 
@@ -1719,5 +1711,14 @@
 %set the displayed GUI item needed for input parameters
 %list_input=feval(ACTION);% input list asked by the selected function
-varargout=feval(ACTION);% input list asked by the selected function
+if ~isequal(path_series,PathName)
+    addpath(PathName)
+end
+eval(['h_function=@' ACTION ';']);
+if ~isequal(path_series,PathName)
+    rmpath(PathName)
+end
+
+varargout=h_function();
+%varargout=feval(ACTION);% input list asked by the selected function
 Param_list={};
 % RootPath=get(handles.RootPath,'String');
@@ -1851,6 +1852,6 @@
          delete(hget_field)%delete opened versions of get_field
      end
-     hseries=get(handles.FieldMenu,'parent');
-     SeriesData=get(hseries,'UserData');
+     %hseries=get(handles.FieldMenu,'parent');
+     SeriesData=get(handles.figure1,'UserData');
      filename=SeriesData.CurrentInputFile;
      if exist(filename,'file')
@@ -1879,6 +1880,6 @@
          delete(hget_field)
      end
-     hseries=get(handles.FieldMenu,'parent');
-     SeriesData=get(hseries,'UserData');
+     %hseries=get(handles.FieldMenu,'parent');
+     SeriesData=get(handles.figure1,'UserData');
      filename=SeriesData.CurrentInputFile_1;
      if exist(filename,'file')
